-- I based this GUI on the one used in the BadBoy anti-spam addon.
-- Consequently, I owe many thanks to Funkydude; permission was given to use his addon in this way.
-- Get BadBoy Anti-Spam here: https://mods.curse.com/addons/wow/bad-boy

local AddonName, AddonTable = ...
local L = AddonTable.Localize
local AddonTitle = select(2, GetAddOnInfo(AddonName))
local PlainAddonTitle = AddonTitle:gsub("|c........", ""):gsub("|r", "")

function OptionsFrame_OnLoad()
SlashCmdList["DROPTIONS"] = droptions_command
	SLASH_DROPTIONS1 = "/dr"
	
StaticPopupDialogs["RESET_STATS"] = {
  text = L["Reset Statistics"] .. "\n\n" .. L["Are you sure?"],
  button1 = L["Yes"],
  button2 = L["No"],
  OnAccept = function()
      resetstats()
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
}
end

function resetstats()
	GlobalDC = 0
	DuelsDeclined = 0
	DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Your statistics have been reset."])
end

function droptions_command()
local droptions = CreateFrame("Frame", "DRConfig", UIParent)
droptions:SetSize(650, 200)
droptions:SetPoint("CENTER")
droptions:SetClampedToScreen(true)
droptions:EnableMouse(true)
droptions:SetMovable(true)
droptions:RegisterForDrag("LeftButton")
droptions:SetScript("OnDragStart", function(self) self:StartMoving() end)
droptions:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
droptions:Show()
local bg = droptions:CreateTexture()
bg:SetAllPoints(droptions)
bg:SetColorTexture(0, 0, 0, 0.5)
local close = CreateFrame("Button", nil, droptions, "UIPanelCloseButton")
close:SetPoint("TOPRIGHT", droptions, "TOPRIGHT", -5, -5)

local title = droptions:CreateFontString(nil, nil, "GameFontNormalLarge")
title:SetPoint("TOPLEFT", 16, -16)
title:SetText(L["DuelResponse"] .." v" .. GetAddOnMetadata("DuelResponse", "Version"))

-- Decline Duel Checkbox

local chkDeclineDuel = CreateFrame("CheckButton", nil, droptions, "OptionsBaseCheckButtonTemplate")
chkDeclineDuel:SetPoint("TOPLEFT", title, "BOTTOMLEFT", 0, -16)

	if DRConfig.DeclineDuel == "ON" then
		chkDeclineDuel:SetChecked(true)
	elseif DRConfig.DeclineDuel == "OFF" then
		chkDeclineDuel:SetChecked(false)
	end

chkDeclineDuel:SetScript("OnClick", function(frame)
	local tick = frame:GetChecked()
	if tick == false then
		DRConfig.DeclineDuel = 'OFF'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Duel requests will not be declined."])
	elseif tick == true then
		DRConfig.DeclineDuel = 'ON'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Duel requests will be declined."])
	end
end)

chkDeclineDuel:SetScript("OnEnter", function(self)
	GameTooltip:SetOwner(self, "ANCHOR_TOP")
	GameTooltip:AddLine(L["Hold down Ctrl or Alt to let a request through."], 1, 1, 1)
	GameTooltip:Show()
end)

local chkDeclineDuelText = droptions:CreateFontString(nil, nil, "GameFontHighlight")
chkDeclineDuelText:SetPoint("LEFT", chkDeclineDuel, "RIGHT", 0, 1)
chkDeclineDuelText:SetText(L["Block all incoming duel requests"])

-- Pet Battle Checkbox

local chkDeclinePetBattle = CreateFrame("CheckButton", nil, droptions, "OptionsBaseCheckButtonTemplate")
chkDeclinePetBattle:SetPoint("TOPLEFT", chkDeclineDuel, "BOTTOMLEFT")

	if DRConfig.DeclinePB == "ON" then
		chkDeclinePetBattle:SetChecked(true)
	elseif DRConfig.DeclinePB == "OFF" then
		chkDeclinePetBattle:SetChecked(false)
	end

chkDeclinePetBattle:SetScript("OnClick", function(frame)
	local tick = frame:GetChecked()
	if tick == false then
		DRConfig.DeclinePB = 'OFF'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Pet battle requests will not be declined."])
	elseif tick == true then
		DRConfig.DeclinePB = 'ON'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Pet battle requests will be declined."])
	end
end)

chkDeclinePetBattle:SetScript("OnEnter", function(self)
	GameTooltip:SetOwner(self, "ANCHOR_TOP")
	GameTooltip:AddLine(L["Hold down Ctrl or Alt to let a request through."], 1, 1, 1)
	GameTooltip:Show()
end)

local chkDeclinePetBattleText = droptions:CreateFontString(nil, nil, "GameFontHighlight")
chkDeclinePetBattleText:SetPoint("LEFT", chkDeclinePetBattle, "RIGHT", 0, 1)
chkDeclinePetBattleText:SetText(L["Block all incoming pet battle requests"])

-- Chat Message Checkbox

local chkShowChatMsg = CreateFrame("CheckButton", nil, droptions, "OptionsBaseCheckButtonTemplate")
chkShowChatMsg:SetPoint("TOPLEFT", chkDeclinePetBattle, "BOTTOMLEFT")

	if DRConfig.ShowChatMessage == "ON" then
		chkShowChatMsg:SetChecked(true)
	elseif DRConfig.ShowChatMessage == "OFF" then
		chkShowChatMsg:SetChecked(false)
	end

chkShowChatMsg:SetScript("OnClick", function(frame)
	local tick = frame:GetChecked()
	
	if tick == false then
		DRConfig.ShowChatMessage = 'OFF'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Chat log messages have been turned off."])
	elseif tick == true then
		DRConfig.ShowChatMessage = 'ON'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Chat log messages have been turned on."])
	end
end)

local chkShowChatMsgText = droptions:CreateFontString(nil, nil, "GameFontHighlight")
chkShowChatMsgText:SetPoint("LEFT", chkShowChatMsg, "RIGHT", 0, 1)
chkShowChatMsgText:SetText(L["Show a message in chat frame when a duel is declined"])

-- Load Message Checkbox

local chkShowLoadMsg = CreateFrame("CheckButton", nil, droptions, "OptionsBaseCheckButtonTemplate")
chkShowLoadMsg:SetPoint("TOPLEFT", chkShowChatMsg, "BOTTOMLEFT")

	if DRConfig.ShowLoadMessage == "ON" then
		chkShowLoadMsg:SetChecked(true)
	elseif DRConfig.ShowLoadMessage == "OFF" then
		chkShowLoadMsg:SetChecked(false)
	end

chkShowLoadMsg:SetScript("OnClick", function(frame)
	local tick = frame:GetChecked()
	
	if tick == false then
		DRConfig.ShowLoadMessage = 'OFF'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Load message disabled."])
	elseif tick == true then
		DRConfig.ShowLoadMessage = 'ON'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Load message enabled."])
	end
end)

local chkShowLoadMsgText = droptions:CreateFontString(nil, nil, "GameFontHighlight")
chkShowLoadMsgText:SetPoint("LEFT", chkShowLoadMsg, "RIGHT", 0, 1)
chkShowLoadMsgText:SetText(L["Welcome message"])


-- Status Text

local statsTitle = droptions:CreateFontString("DROptionsConfigTitle", nil, "GameFontNormalLarge")
statsTitle:SetPoint("BOTTOMLEFT", droptions, "BOTTOMLEFT", 10, 10)
statsTitle:SetText(L["Total duels blocked: "] .. tonumber(GlobalDC) .. " (" ..  UnitName("player") .. ": " .. tonumber(DuelsDeclined) .. ")")

-- Reset Stats Button

local btnResetStats = CreateFrame("Button", nil, droptions, "UIPanelButtonTemplate")
btnResetStats:SetSize(200,25)
btnResetStats:SetPoint("BOTTOMRIGHT", droptions, "BOTTOMRIGHT", -10, 5)
btnResetStats:SetScript("OnClick", function(frame)
	StaticPopup_Show("RESET_STATS")
end)
btnResetStats:SetText(L["Reset Statistics"])

end